<?php
// $Author: perlstalker $
// $Id: sasql_db.php,v 1.11 2005/03/14 18:35:57 perlstalker Exp $

require_once('DB.php');

function sasql_DBConnect ( $dsn ) {
  $dbh = DB::connect ($dsn, true);
  if (DB::isError($dbh) ) { # || DB::isWarning($dbh)) {
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_DBConnect',
			    DB::errorMessage($dbh)));
    return "";
  }

  return $dbh;
}

function sasql_DBDisconnect ( $dbh ) {
  $dbh->disconnect();
  return "";
}

function sasql_ReadWBList ( $dbh, $table, $username ) {
  $query = sprintf ("SELECT * from %s WHERE username = '%s' AND (preference = 'whitelist_from' OR preference = 'unwhitelist_from' OR preference = 'blacklist_from' OR preference = 'unblacklist_from' OR preference = 'whitelist_to') order by preference,value asc", $table, $username);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_ReadWBList',
			    DB::errorMessage($dbh)));
    return "";
  }

  $wbList = array('whitelist_from' => array(),
		  'blacklist_from' => array(),
		  'unwhitelist_from' => array(),
		  'unblacklist_from' => array(),
		  'whitelist_to' => array());
  while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
    array_push ($wbList[strtolower($row['preference'])],
		array('value' => $row['value'],
		      'prefid' => $row['prefid'],
		      'preference' => strtolower($row['preference'])));
  }
  return $wbList;
}

// See if $addr is in $username's white or blacklist.
// $wblist = 'w' => Whitelist
// $wblist = 'b' => Blacklist
function sasql_AddrInWBList ($dbh, $table, $username, $wblist, $addr)
{
  $wlquery = sprintf ("SELECT * from %s where username = '%s' and (preference = 'whitelist_from' and value = '%s')",
		      $table,
		      $username,
		      $addr
		      );
  $blquery = sprintf ("SELECT * from %s where username = '%s' and (preference = 'blacklist_from' and value = '%s')",
		      $table,
		      $username,
		      $addr
		      );

  $res = false;
  if ($wblist == 'w') {
    $res = $dbh->query($wlquery);
  } elseif ($wblist == 'b') {
    $res = $dbh->query($blquery);
  }

  $found = 0;
  if (DB::isError($res)) {
    // bad stuff
  } else {
    $row = $res->fetchRow(DB_FETCHMODE_ASSOC);
    $found = $row['value'];
  }

  if ($found) { return 1; }
  else { return 0; }
}

// Same as above but useful if you don't have an existing connection.
// This may be removed at some later date because I think it may be
// better to use _DBConnect+_AddrInWBList+_DBDisconnect instead.
function sasql_AddrInWBList_dsn ($dsn, $table, $username, $wblist, $addr)
{
  //connect
  $dbh = sasql_DBConnect ($dsn);
  if (DB::isError($dbh)) {
  } else {
    $found = sasql_AddrInWBList ($dbh, $table, $username, $wblist, $addr);
  }
  //disconnect
  sasql_DBDisconnect ($dbh);
  return $found;
}

//function sasql_WriteWBList ($dsn, $table, $username, $wbList) {}

function sasql_ReadPrefs ( $dbh, $table, $username ) {
  global $sa_params;
  $query = sprintf ("SELECT * from %s WHERE username = '%s' AND (preference != 'whitelist_from' OR preference != 'blacklist_from') order by preference desc",
		    $table, $username);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_ReadPrefs',
			    DB::errorMessage($dbh)));
    return "";
  }

  $prefs = array();
  while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
    $p = $row['preference'];
    if (isset($sa_params[$row['preference']]['multiple'])
        and $sa_params[$row['preference']]['multiple']) {
      if (! isset($prefs[$row['preference']])) {
	$prefs[$row['preference']] = array ('value' => array(),
					    'prefid' => array());
      }
      if ($sa_params[$row['preference']]['one_line']) {
	$xValues = explode (' ', $row['value']);
	foreach ($xValues as $v) {
	  array_push ($prefs[$row['preference']]['value'], $v);
	  array_push ($prefs[$row['preference']]['prefid'], $row['prefid']);
	}
      } else {
	array_push ($prefs[$row['preference']]['value'], $row['value']);
	array_push ($prefs[$row['preference']]['prefid'], $row['prefid']);
      }
    } else {
      $prefs[$row['preference']] = array ('value' => $row['value'],
					  'prefid' => $row['prefid']);
    }
  }
  return $prefs;
}

//function sasql_WritePrefs ( $dsn, $table, $username, $prefs ) {}

function sasql_UpdatePref ( $dbh, $table, $username, $prefid, $preference, $value ) {
  $query = sprintf ("UPDATE %s set value='%s', preference='%s' where prefid='%s' and username='%s'", $table, $value, strtolower($preference), $prefid, $username);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_UpdatePref',
			    DB::errorMessage($dbh)));
  }
}

function sasql_UpdatePref_multiple ( $dbh, $table, $username,
				     $preference, $value ) {
  // NOTE: $value is an array
  // There is probably a cleaner way to do this. I'll worry about it later.
  // Delete all values for this preference and user.
  global $sa_params;
  $query = sprintf ("DELETE from %s where username = '%s' and preference='%s'",
		    $table,
		    $username,
		    $preference);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error: %s"),
			    'sasql_UpdatePref_multiple',
			    //DB::errorMessage($dbh)));
			    $res->getDebugInfo()));
  }
  // (Re)Add the new values.
  sasql_AddPref_multiple ($dbh, $table, $username, $preference, $value);
}

function sasql_AddPref ( $dbh, $table, $username, $preference, $value ) {
  $query = sprintf ("INSERT INTO %s (username,value,preference) VALUES('%s', '%s', '%s')", $table, $username, $value, strtolower($preference));
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_AddPref',
			    DB::errorMessage($dbh)));
  }
}

function sasql_AddPref_multiple ( $dbh, $table, $username,
				  $preference, $value ) {
  // NOTE: $value is an array
  global $sa_params;
  if (is_array($value)) {
    if ($sa_params[$preference]['one_line']) {
      $one_val = implode (' ', $value);
      sasql_AddPref ($dbh, $table, $username, $preference, $one_val);
    } else {
      foreach ($value as $v) {
	$query = sprintf ("INSERT INTO %s (username,value,preference) VALUES('%s', '%s', '%s')", $table, $username, $v, strtolower($preference));
	$res = $dbh->query($query);
	if (DB::isError($res)) {
	  sasql_DBDisconnect($dbh);
	  include_once (SM_PATH.'functions/display_messages.php');
	  logout_error (sprintf ( _("sasql_AddPref_multiple Database error: %s"),
				  DB::errorMessage($dbh)));
	}
      }
    }
  } else {
    sasql_AddPref ($dbh, $table, $username, $preference, $value);
  }
}

function sasql_DelPref ( $dbh, $table, $username, $prefid ) {
  $query = sprintf ("DELETE from %s where prefid='%s' and username='%s'", $table, $prefid, $username);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_DelPref',
			    DB::errorMessage($dbh)));
  }
}

function sasql_DelPref_value ($dbh, $table, $username, $pref, $value) {
  $query = sprintf ("DELETE from %s where preference='%s'"
		    . "and value = '%s' and username='%s'",
		    $table, $pref, $value, $username);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_DelPref_value',
			    DB::errorMessage($dbh)));
  }
}

function sasql_DelPref_name ($dbh, $table, $username, $pref) {
  $query = sprintf ("DELETE from %s where preference='%s'"
		    . " and username='%s'",
		    $table, $pref, $username);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error %s: %s"),
			    'sasql_DelPref_name',
			    DB::errorMessage($dbh)));
  }
}

function sasql_GetPref ( $dbh, $table, $username, $prefid ) {
  $query = sprintf ("SELECT * from %s WHERE username = '%s' AND prefid = %s",
		    $table, $username, $prefid);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_GetPref',
			    DB::errorMessage($dbh)));
    return "";
  }

  if ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
    $pref = array ('value' => $row['value'],
		   'preference' => strtolower($row['preference']),
		   'prefid' => $row['prefid']);
  } else {
    $pref = "";
  }
  return $pref;
}

// if you know the list and email address, then return the prefid
// so that can be used in other function calls such as to delete an
// address from the DB.
function sasql_GetID ( $dbh, $table, $username, $preference, $value) {
  $query = sprintf ("SELECT * from %s WHERE username = '%s' AND " .
                    "preference='%s' AND value='%s'",
		    $table, $username, $preference, $value);
  $res = $dbh->query($query);
  if (DB::isError($res)) {
    sasql_DBDisconnect($dbh);
    include_once (SM_PATH.'functions/display_messages.php');
    /* To translators: %s's are the function name
       and PEAR generated error message.
    */
    logout_error (sprintf ( _("Database error in %s: %s"),
			    'sasql_GetID',
			    DB::errorMessage($dbh)));
    return "";
  }

  if ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
    $pref = $row['prefid'];
  } else {
    $pref = "";
  }
  return $pref;
}

?>
